//class for storing accounts that MailWidget can handle

function mkiiAccount() {
	this.valid = true;
	this.AccountName = "";
	this.AccountPath = "";
	this.AccountType = "";
	this.AuthenticationScheme = "";
	this.Hostname = "";
	this.PortNumber = 0;
	this.SSLEnabled = false;
	this.Username = "";
	this.uniqueId = "";
	this.Password = "";
	//this.indicator = 0;
	this.newLine = "\n";
	this.handler = null;
	//this.fail = false;

	this.debug = function() {
		debug( "valid : " + this.valid );
		debug( "AccountName : " + this.AccountName );
		debug( "AccountPath : " + this.AccountPath );
		debug( "AccountType : " + this.AccountType );
		debug( "AuthenticationScheme : " + this.AuthenticationScheme );
		debug( "Hostname : " + this.Hostname );
		debug( "PortNumber : " + this.PortNumber );
		debug( "SSLEnabled : " + this.SSLEnabled );
		debug( "Username : " + this.Username );
		debug( "uniqueId : " + this.uniqueId );
		debug( "Password : " + this.Password );
	};
	
	//this.doneHandler = function() {
	//	debug( "doneHandler()" );
	//};
	
	//this.failHandler = function() {
	//	debug( "failHandler()" );
	//	
	//	fail = true;
	//};
	
	function debug( STRING ) {
		_debug( "mkiiAccount : " + STRING );
	}
}



//class for acquireing MailAccounts
//mailAccounts is a variable that must be passed to the constructor. the accounts are stored in there.

function mkiiMailAccounts( MAIL_ACCOUNTS ) {
	var state;
	var callWhenDone;

	function debug( string ) {
		_debug( "mkiiMailAccounts : " + string );
	}

	this.acquireMailAccounts = function( mailAccountsLoaded ) {
		callWhenDone = mailAccountsLoaded;
		getSettings();
	};
	
	function getSettings () {
		state = "";
		var mailAccountSettings = widget.system( "/usr/bin/defaults read ~/Library/Preferences/com.apple.mail MailAccounts", accountEndHandler );
		//var mailAccountSettings = widget.system( "/usr/bin/defaults read ~/Desktop/com.apple.mail MailAccounts", accountEndHandler );
		mailAccountSettings.onreadoutput = stdout;
		mailAccountSettings.onreaderror = stderr;
	}

	function stderr( result ) {
		debug( "stderr : " + result );
	}

	function stdout( result ) {
		//debug( "stdout : " + result );
		state += result;
	}

	function accountEndHandler( result ) {
		debug( "accountEndHandler : " + result );
		var mailAccountSettings = state;
		//debug( mailAccountSettings );
		
		if ( mailAccountSettings.indexOf( "\n)\n" ) == -1 ) {
			//debug( "ERROR in retrieving accounts... retrying" );
			getSettings();
		} else {
			debug( mailAccountSettings );
			var account = mailAccountSettings.split( "\n    }," );	//need to be more careful with the things I do, Conflicted with }, inside an account before

			for ( var i = 0; i < account.length; i++ ) {
				var currentAccount = new mkiiAccount();
				var setting = account[i].split( "\n" );
				
				for ( var j = 0; j < setting.length; j++ ) {
					var begin = setting[j].indexOf( " = " );
					var end = setting[j].indexOf( ";" );
					//debug( setting[j] );
					
					if ( setting[j].indexOf( "\"" ) != -1 ) {
						begin++;
						end--;
					}
					
					if ( setting[j].indexOf( "AccountName" ) != -1 )			currentAccount.AccountName = setting[j].substring( begin + 3, end );
					if ( setting[j].indexOf( "AccountPath" ) != -1 )			currentAccount.AccountPath = setting[j].substring( begin + 3, end );
					if ( setting[j].indexOf( "AccountType" ) != -1 )			currentAccount.AccountType = setting[j].substring( begin + 3, end );
					if ( setting[j].indexOf( "AuthenticationScheme" ) != -1 )	currentAccount.AuthenticationScheme = setting[j].substring( begin + 3, end );
					if ( setting[j].indexOf( "Hostname" ) != -1 )				currentAccount.Hostname = setting[j].substring( begin + 3, end );
					if ( setting[j].indexOf( "PortNumber" ) != -1 )				currentAccount.PortNumber = parseInt( setting[j].substring( begin + 3, end ) );
					if ( setting[j].indexOf( "SSLEnabled" ) != -1 )				currentAccount.SSLEnabled = setting[j].substring( begin + 3, end );
					if ( setting[j].indexOf( "Username" ) != -1 )				currentAccount.Username = setting[j].substring( begin + 3, end );
					if ( setting[j].indexOf( "uniqueId" ) != -1 )				currentAccount.uniqueId = setting[j].substring( begin + 3, end );
				}
				
				if ( currentAccount.SSLEnabled == "YES" ) {
					currentAccount.SSLEnabled = true;
				} else {
					currentAccount.SSLEnabled = false;
				}

				if ( currentAccount.AccountType == "POPAccount" ) {
					if ( !currentAccount.PortNumber ) {
						debug( "completing PortNumber" );
						
						if ( currentAccount.SSLEnabled ) {
							currentAccount.PortNumber = 995;
						} else {
							currentAccount.PortNumber = 110;
						}
					}
					
					if ( currentAccount.AccountPath == undefined ) {
						debug( "missing AccountPath" );
						currentAccount.valid = false;
					}
				} else if ( ( currentAccount.AccountType == "IMAPAccount" ) || ( currentAccount.AccountType == "iToolsAccount" ) || ( currentAccount.AccountType == "ExchangeAccount" ) ) {
					if ( !currentAccount.PortNumber ) {
						debug( "completing PortNumber" );
						
						if ( currentAccount.SSLEnabled ) {
							currentAccount.PortNumber = 993;
						} else {
							currentAccount.PortNumber = 143;
						}
					}
					
					if ( currentAccount.AccountType == "iToolsAccount" ) {
						currentAccount.Hostname = "mail.mac.com"
					} else if ( currentAccount.AccountType == "ExchangeAccount" ) {
						currentAccount.Hostname = widget.system( "/usr/bin/defaults read ~/Library/Preferences/com.apple.IISSupport ExchangeServerHostname", null ).outputString.split( "\n" )[0];
						debug( "ExchangeAccount : Host - " + currentAccount.Hostname );
						currentAccount.Username = widget.system( "/usr/bin/defaults read ~/Library/Preferences/com.apple.IISSupport IISUser", null ).outputString.split( "\n" )[0];
						debug( "ExchangeAccount : User - " + currentAccount.Username );
					}
				} else {
					debug( "missing or unknown AccountType" );
					currentAccount.valid = false;
				}
				
				if ( currentAccount.AuthenticationScheme == undefined ) {
					debug( "completing AuthenticationScheme" );
					currentAccount.AuthenticationScheme = "";
				} else if ( ( currentAccount.AuthenticationScheme != "" ) && ( currentAccount.AuthenticationScheme != "CRAM-MD5" ) ) {
					debug( "fixMe : unknown AuthenticationScheme, trying plain" );
					currentAccount.AuthenticationScheme = "";
				}
				
				if ( currentAccount.AccountName == undefined ) {
					debug( "missing AccountName" );
					currentAccount.valid = false;
				}
				
				if ( currentAccount.Hostname == undefined ) {
					debug( "missing Hostname" );
					currentAccount.valid = false;
				}
				
				if ( currentAccount.Username == undefined ) {
					debug( "missing Username" );
					currentAccount.valid = false;
				}
				
				if ( currentAccount.uniqueId == undefined ) {
					debug( "missing uniqueId" );
					currentAccount.valid = false;
				}
				
				currentAccount.debug();
				
				if ( currentAccount.valid ) {
					//debug( "/usr/bin/security find-internet-password -a " + currentAccount.Username + " -s " + currentAccount.Hostname + " -g" );
					//currentAccount.Password = widget.system( "/usr/bin/security find-internet-password -a " + currentAccount.Username + " -s " + currentAccount.Hostname + " -g", null ).errorString.split( "\"")[1];
					MAIL_ACCOUNTS.push( currentAccount );
				}
			}

			debug( MAIL_ACCOUNTS );
			callWhenDone();
		}
	}
}