var g_name = null;
var g_checkInterval = 15;
var g_audioVolume = 256;
var g_customAudio = null;
var g_autoUpdate = true;
var g_updateLink = "http://www.kwasi-ich.de/";
var g_performAutoUpdate = null;
var g_pasteTarget = 1; //1 = front, 2 = audio, 0 = none

function UIinit() {
	debug( "UIinit()" );

	document.getElementById( "accountSelector" ).style.display = "none";	//quirk fix for unhideable lists
	document.getElementById( "back" ).style.display = "none";	//quirk fix for stacks on Tiger
	
	//quirk fix for localizing and resetting audio files since QuickTime searches files with relative path, relative to the previous file
	var qtElement = document.getElementById("audioAnnouncementPlayer");
	g_UIaudioRestore = qtElement.GetURL();
	g_UIaudioRestore = g_UIaudioRestore + dashcode.getLocalizedString( "«en.lproj/»" ) + "0.m4a";
	qtElement.SetResetPropertiesOnReload(false);
	qtElement.SetURL( g_UIaudioRestore );
}

function UIpaste( EVENT )
{
	debug( "UIpaste( " + EVENT + " )" );
	
	try {
		var uriList = getFilesFromEvent( EVENT, false );
		
		if ( uriList.length > 0 ) {
			switch ( g_pasteTarget ) {
				case 2:
					g_customAudio = uriList;
					document.getElementById("audioPlayerDropBox").style.background = "url( Images/dropWell.png ) no-repeat 0 -108px"
					break;
				case 1:
					var POSIXfileList = new Array();
					var POSIXfileString;
					
					for ( var uri in uriList) {
						POSIXfileString = unescape( uriList[uri] ).split( "localhost" )[1];
						POSIXfileString = POSIXfileString.replace( /\\/g, "\\\\" );
						POSIXfileString = POSIXfileString.replace( /"/g, "\\\"" );
						POSIXfileList.push( POSIXfileString )
					}
					
					var executeString = "tell application \"Mail\" to open { POSIX file \"" + POSIXfileList[0] + "\""
					
					for ( var uri = 1; uri < POSIXfileList.length; uri++ ) {
						executeString += ", POSIX file \"" + POSIXfileList[uri] + "\"";
					}
					
					executeString += " }";
					executeString = executeString.replace( /\\/g, "\\\\" );
					executeString = executeString.replace( /"/g, "\\\"" );
					widget.system( "osascript -e \"" + executeString + "\"", function() {} );
					break;
				default:
					break;
			}
			
			EVENT.stopPropagation();
			EVENT.preventDefault();
		}
	} catch ( ex ) {
		debug( ex );
	}
}





/////////////////
//			   //
//  FrontSide  //
//			   //
/////////////////



/*********************/
/* ActivityIndicator */
/*********************/

var g_UIactivityIndicatorAnimator = null;

function UIactivityIndicator( BOOL )
{
	debug( "UIactivityIndicator( " + BOOL + " )" );
	
	var itemToAnimate = document.getElementById( "activityIndicator" );
	var itemToAnimateStep = 0;

	var animationHandler = function( ANIMATION, CURRENT, START, FINISH ) {
		itemToAnimate.style.background = "url( Images/Async.png ) no-repeat 0 " + ( -16 * itemToAnimateStep ) + "px"
		itemToAnimateStep++;

		if ( itemToAnimateStep == 12 ) {
			itemToAnimateStep = 0;
		}

		if ( START ) {
			itemToAnimate.style.visibility = "visible";
		}

		if ( FINISH ) {
			itemToAnimate.style.visibility = "hidden";
		}
	};

	if ( g_UIactivityIndicatorAnimator ) {
		g_UIactivityIndicatorAnimator.stop();
		delete g_UIactivityIndicatorAnimator;
	}

	if ( BOOL ) {
		g_UIactivityIndicatorAnimator = new AppleAnimator( 60000, 40, 0, 1, animationHandler );
	} else {
		g_UIactivityIndicatorAnimator = new AppleAnimator( 0, 40, 0, 1, animationHandler );
	}

	g_UIactivityIndicatorAnimator.start();
}



/****************/
/* NewMailBadge */
/****************/

function UIbadgeCount( COUNT )
{
	debug( "UIbadgeCount( " + COUNT + " )" );
	
	var itemToFade = document.getElementById( "newMailBadge" );
	var itemToCountUp = document.getElementById( "newMailBadgeCount" );
	var endCount = COUNT;
	var startCount = parseInt( itemToCountUp.innerText );
	var startOpacity = parseFloat( itemToFade.style.opacity );
	
	if ( isNaN( startCount ) ) {
		startCount = 0;
	}
	
	if ( isNaN( startOpacity ) ) {
		startOpacity = 0;
	}

	if ( (endCount - startCount) == 0 ) {
		return;
	}

	var fadeHandler = function( ANIMATION, CURRENT, START, FINISH ) {
		var count = Math.round( CURRENT * endCount + (1 - CURRENT) * startCount );
		itemToFade.style.opacity = CURRENT * 1 + (1-CURRENT) * startOpacity;
		itemToCountUp.innerText = count;

		if ( count > 9999 ) {
			document.getElementById( "newMailBadge" ).style.background = "url( Images/NewMail5.png ) no-repeat 50% 50%";
		} else if ( count > 999 ) {
			document.getElementById( "newMailBadge" ).style.background = "url( Images/NewMail4.png ) no-repeat 50% 50%";
		} else if ( count > 99 ) {
			document.getElementById( "newMailBadge" ).style.background = "url( Images/NewMail3.png ) no-repeat 50% 50%";
		} else {
			document.getElementById( "newMailBadge" ).style.background = "url( Images/NewMail2.png ) no-repeat 50% 50%";
		}

		if ( START ) {
			itemToFade.style.visibility = "visible";
		}
		
		if ( FINISH ) {
			if ( CURRENT == 0 ) {
				itemToFade.style.visibility = "hidden";	//quirk fix avoid hovering event on invisible items
			}
		}
		
	};

	if ( endCount > 0) {
		new AppleAnimator( 500, 13, 0, 1, fadeHandler ).start();
	} else {
		endCount = startCount;
		startCount = 0;
		startOpacity = 0;
		new AppleAnimator( 500, 13, 1, 0, fadeHandler ).start();
	}
}



/**************/
/* MailHeader */
/**************/

var g_UIMailHeaderAnimator = null;

function UIshowMailHeader( EVENT )
{
	debug( "UIshowMailHeader( " + EVENT + " )" );
	
	var itemToFade = document.getElementById( "mailHeader" );
	var startOpacity = parseFloat( itemToFade.style.opacity );

	if ( isNaN( startOpacity ) ) {
		startOpacity = 0;
	}

	var fadeInHandler = function( ANIMATION, CURRENT, START, FINISH ) {
		itemToFade.style.opacity = CURRENT;

		if ( START ) {
			itemToFade.style.visibility = "visible";
		}
	};

	var fadeOutHandler = function( ANIMATION, CURRENT, START, FINISH ) {
		itemToFade.style.opacity = CURRENT;

		if ( FINISH ) {
			itemToFade.style.visibility = "hidden";
		}
	};
	
	if ( g_UIMailHeaderAnimator ) {
		g_UIMailHeaderAnimator.stop();
		delete g_UIMailHeaderAnimator;
	}
	
	if ( EVENT.type == "mouseover" ) {
		g_UIMailHeaderAnimator = new AppleAnimator( 125, 13, startOpacity, 1, fadeInHandler );
	} else {
		g_UIMailHeaderAnimator = new AppleAnimator( 250, 13, startOpacity, 0, fadeOutHandler );
	}

	g_UIMailHeaderAnimator.start();
}

function UIsetMailHeader( FROM, SUBJECT )
{
	debug( "UIsetMailHeader( " + FROM + ", " + SUBJECT + " )" );

	document.getElementById( "mailHeaderFrom" ).innerText = FROM;
	document.getElementById( "mailHeaderSubject" ).innerText = SUBJECT;
}



/**************/
/* LaunchMail */
/**************/

function UIlaunchMail()
{
	debug( "UIlaunchMail()" );
	
	widget.openApplication( "com.apple.Mail" );

	for ( var acc in g_MailAccounts ) {
        if ( g_MailAccounts[acc].handler ) {
			widget.system( "osascript -e 'tell application \"Mail\" to check for new mail for account \"" + g_MailAccounts[acc].AccountName + "\"'", function () {} );
		}
	}
	
	UIbadgeCount( 0 );
}

function UIlaunchMailDragDrop( EVENT )
{
	debug( "UIlaunchMailDragDrop( " + EVENT + " )" );

	var uriList = getFilesFromEvent( EVENT, true );
	var POSIXfileList = new Array();
	var POSIXfileString;
	
	for ( var uri in uriList) {
		POSIXfileString = unescape( uriList[uri] ).split( "localhost" )[1];
		POSIXfileString = POSIXfileString.replace( /\\/g, "\\\\" );
		POSIXfileString = POSIXfileString.replace( /"/g, "\\\"" );
		POSIXfileList.push( POSIXfileString )
	}
	
	var executeString = "tell application \"Mail\" to open { POSIX file \"" + POSIXfileList[0] + "\""
	
	for ( var uri = 1; uri < POSIXfileList.length; uri++ ) {
		executeString += ", POSIX file \"" + POSIXfileList[uri] + "\"";
	}
	
	executeString += " }";
	executeString = executeString.replace( /\\/g, "\\\\" );
	executeString = executeString.replace( /"/g, "\\\"" );
	widget.system( "osascript -e \"" + executeString + "\"", function() {} );
	
	EVENT.stopPropagation();
	EVENT.preventDefault();
}

function UIlaunchMailDrag( EVENT )
{
	//debug( "UIlaunchMailDrag( " + EVENT + " )" );

	EVENT.stopPropagation();
	EVENT.preventDefault();
}



/**********************/
/* UpdateNotification */
/**********************/

function UIaskForUpdate( VERSION, LINK, DOIT )
{
	debug( "UIaskForUpdate( " + VERSION + ", " + LINK + ", " + DOIT + " )" );
	
	var textAreaToChange = document.getElementById( "updateNotificationText" );
	var newTextAreaText = dashcode.getLocalizedString( dashcodePartSpecs.updateNotificationText.text );
	newTextAreaText = newTextAreaText.replace( /%f/, VERSION );
	textAreaToChange.innerText = newTextAreaText;
	g_updateLink = LINK;
	g_performAutoUpdate = DOIT;
	var itemToFade = document.getElementById( "updateNotification" );

	var fadeHandler = function( ANIMATION, CURRENT, START, FINISH ) {
		itemToFade.style.opacity = CURRENT;

		if ( START ) {
			itemToFade.style.visibility = "visible";
		}
	};

	new AppleAnimator( 250, 13, 0, 1, fadeHandler ).start();
}

function UIgoToUpdate()
{
	debug( "UIgoToUpdate()" );
	
	widget.openURL( g_updateLink );
}

function UIskipUpdate()
{
	debug( "UIskipUpdate()" );
	
	var itemToFade = document.getElementById( "updateNotification" );

	var fadeHandler = function( ANIMATION, CURRENT, START, FINISH ) {
		itemToFade.style.opacity = CURRENT;

		if ( FINISH ) {
			itemToFade.style.visibility = "hidden";
		}
	};

	new AppleAnimator( 500, 13, 1, 0, fadeHandler ).start();
}

function UIperformUpdate()
{
	debug( "UIperformUpdate()" );
	
	if ( g_performAutoUpdate ) {
		g_performAutoUpdate( UIrestartAfterUpdate );
	}
}

function UIrestartAfterUpdate()
{
	debug( "UIrestartAfterUpdate()" );
	
	var itemToFade = document.getElementById( "updateNotificationReboot" );

	var fadeHandler = function( ANIMATION, CURRENT, START, FINISH ) {
		itemToFade.style.opacity = CURRENT;

		if ( START ) {
			itemToFade.style.visibility = "visible";
		}
	};
	
	new AppleAnimator( 250, 13, 0, 1, fadeHandler ).start();
}

function UIeditName()
{
	debug( "UIeditName()" );
	
	var nameTextfield = document.getElementById( "nameTextfield" );
	nameTextfield.style.visibility = "visible";
	nameTextfield.focus();
}

function UIchangeName( EVENT )
{
	debug( "UIchangeName( " + EVENT + " )" );
	
	var nameTextfield = document.getElementById( "nameTextfield" );
	nameTextfield.style.visibility = "hidden";
	UIsetName( nameTextfield.value );
	
	widget.setPreferenceForKey( nameTextfield.value, widget.identifier + "-" + "name" );	//fix me: put me somewhere else
	
	EVENT.stopPropagation();
	EVENT.preventDefault();
}

function UIsetName( STRING )
{
	debug( "UIsetName( " + STRING + " )" );
		
	g_name = STRING;
	document.getElementById( "nameTextfield" ).value = STRING;
	UIdisplayName();
}

function UIdisplayName()
{
	if ( g_name ) {
		document.getElementById( "nameText" ).innerText = g_name;
	} else {
		for ( var acc in g_MailAccounts ) {
			if ( g_MailAccounts[acc].handler ) {
				document.getElementById( "nameText" ).innerText = g_MailAccounts[acc].AccountName;
				return;
			}
		}
		
		document.getElementById( "nameText" ).innerText = "";
	}
}



////////////////
//			  //
//  BackSide  //
//			  //
////////////////



/*******************/
/* AccountSelector */
/*******************/

var g_UIselectedAccountIndex = -1;
var g_UIaccountList = {
	_rowData: [],

	numberOfRows: function() {
		return this._rowData.length;
	},

	prepareRow: function( ROW_ELEMENT, ROW_INDEX, TEMPLATE_ELEMENTS ) {
		if ( TEMPLATE_ELEMENTS.accountSelectorListLabel ) {
			TEMPLATE_ELEMENTS.accountSelectorListLabel.innerText = this._rowData[ROW_INDEX];
		}

		if ( TEMPLATE_ELEMENTS.accountSelectorListIndicator ) {
			TEMPLATE_ELEMENTS.accountSelectorListIndicator.object.setValue(0);
		}

		ROW_ELEMENT.onclick = function() {
			debug( "ROW_ELEMENT.onclick: " + ROW_ELEMENT + " " + ROW_INDEX );
			verifyAccount( ROW_INDEX );
		};
	}
};

function UIshowAccountSelector()
{
	debug( "UIshowAccountSelector()" );

	var itemToFade = document.getElementById( "accountSelector" );
	var itemToRefresh = document.getElementById( "accountSelectorScrollArea" );

	var fadeHandler = function( ANIMATION, CURRENT, START, FINISH ) {
		itemToFade.style.opacity = CURRENT;
		itemToRefresh.object.refresh();	//quirk fix for not showing up scrollbar

		if ( START ) {
			itemToFade.style.visibility = "visible";
			itemToFade.style.display = "block";	//quirk fix for unhidable lists
		}
	};

	new AppleAnimator( 250, 13, 0, 1, fadeHandler ).start();
}

function UIhideAccountSelector()
{
	debug( "UIhideAccountSelector()" );
	
	var itemToFade = document.getElementById( "accountSelector" );

	var fadeHandler = function( ANIMATION, CURRENT, START, FINISH ) {
		itemToFade.style.opacity = CURRENT;

		if ( FINISH ) {
			itemToFade.style.visibility = "hidden";
			itemToFade.style.display = "none";	//quirk fix for unhidable lists
		}
	};

	new AppleAnimator( 500, 13, 1, 0, fadeHandler ).start();
}

function UIaddToAccountList( NAME )
{
	debug( "UIaddToAccountList( " + NAME + " )" );

	g_UIaccountList._rowData.push( NAME );
	document.getElementById("accountSelectorList").object.reloadData();
	document.getElementById("accountSelectorScrollArea").object.refresh();
}

function UIsetIndicator( INDEX, VALUE )
{
	debug( "UIsetIndicator( " + INDEX + ", " + VALUE + " )" );
	
	document.getElementById("accountSelectorList").object.rows[INDEX].object.templateElements.accountSelectorListIndicator.object.setValue( VALUE );
}

function UIgetIndicator( INDEX )
{
	debug( "UIgetIndicator( " + INDEX + " )" );
	
	return document.getElementById("accountSelectorList").object.rows[INDEX].object.templateElements.accountSelectorListIndicator.object.value;
}

function verifyAccount( INDEX )
{
	debug( "verifyAccount( " + INDEX + " )" );
	
	g_UIselectedAccountIndex = INDEX;
	UIshowVerifyAccount();
}

function UIshowVerifyAccount()
{
	debug( "UIshowVerifyAccount()" );

	var itemToFade = document.getElementById( "verifyAccount" );

	var fadeHandler = function( ANIMATION, CURRENT, START, FINISH ) {
		itemToFade.style.opacity = CURRENT;

		if ( START ) {
			itemToFade.style.visibility = "visible";
			document.getElementById( "verifyAccountStatusIndicator" ).object.setValue( UIgetIndicator( g_UIselectedAccountIndex ) );
			document.getElementById( "verifyAccountPassword" ).value = g_MailAccounts[g_UIselectedAccountIndex].Password;
		}

		if ( FINISH ) {
			document.getElementById( "verifyAccountPassword" ).focus();
		}
	};

	new AppleAnimator( 250, 13, 0, 1, fadeHandler ).start();
}

function UIhideVerifyAccount()
{
	debug( "UIhideVerifyAccount()" );

	var itemToFade = document.getElementById( "verifyAccount" );

	var fadeHandler = function( ANIMATION, CURRENT, START, FINISH ) {
		itemToFade.style.opacity = CURRENT;

		if ( FINISH ) {
			itemToFade.style.visibility = "hidden";
		}
	};

	new AppleAnimator( 500, 13, 1, 0, fadeHandler ).start();
}

function UIperformVerifyAccount( EVENT )
{
	debug( "UIperformVerifyAccount( " + EVENT + " )" );

	g_MailAccounts[g_UIselectedAccountIndex].Password = document.getElementById( "verifyAccountPassword" ).value;

	if ( g_MailAccounts[g_UIselectedAccountIndex].AccountType == "POPAccount" ) {	//handle POP3
		g_MailAccounts[g_UIselectedAccountIndex].handler = new mkiiPopClient( g_MailAccounts[g_UIselectedAccountIndex], UIverifyAccountSuccess, function() {}, UIverifyAccountFail, function() {} );
	} else {	//handle IMAP
		g_MailAccounts[g_UIselectedAccountIndex].handler = new mkiiImapClient( g_MailAccounts[g_UIselectedAccountIndex], UIverifyAccountSuccess, function() {}, UIverifyAccountFail, function() {} );
	}

	document.getElementById( "verifyAccountStatusIndicator" ).object.setValue( 2 );
	UIsetIndicator(g_UIselectedAccountIndex, 2);
	g_MailAccounts[g_UIselectedAccountIndex].handler.checkMail();
	
	EVENT.stopPropagation();
	EVENT.preventDefault();
}

function UIverifyAccountSuccess()
{
	debug( "UIverifyAccountSuccess()" );
	
	document.getElementById( "verifyAccountStatusIndicator" ).object.setValue( 1 );
	UIsetIndicator( g_UIselectedAccountIndex, 1 );

	delete g_MailAccounts[g_UIselectedAccountIndex].handler;

	if ( g_MailAccounts[g_UIselectedAccountIndex].AccountType == "POPAccount" ) {	//handle POP3
		g_MailAccounts[g_UIselectedAccountIndex].handler = new mkiiPopClient( g_MailAccounts[g_UIselectedAccountIndex], collectCount, collectHeaders, collectFail, collectDone );
	} else {	//handle IMAP
		g_MailAccounts[g_UIselectedAccountIndex].handler = new mkiiImapClient( g_MailAccounts[g_UIselectedAccountIndex], collectCount, collectHeaders, collectFail, collectDone );
	}

	UIhideVerifyAccount();
}

function UIverifyAccountFail()
{
	debug( "UIverifyAccountFail()" );
	
	document.getElementById( "verifyAccountStatusIndicator" ).object.setValue( 3 );
	UIsetIndicator( g_UIselectedAccountIndex, 3 );
	delete g_MailAccounts[g_UIselectedAccountIndex].handler;
	g_MailAccounts[g_UIselectedAccountIndex].handler = null;
}

function UIcancelVerifyAccount()
{
	debug( "UIcancelVerifyAccount()" );

	if ( g_MailAccounts[g_UIselectedAccountIndex].handler ) {
		g_MailAccounts[g_UIselectedAccountIndex].handler.kill();
		UIverifyAccountFail();
	}
	
	UIremoveAccount();	//fix me: make the removing and cancelling more meaningful
	UIhideVerifyAccount();
}

function UIremoveAccount()
{
	debug( "UIremoveAccount()" );

	g_MailAccounts[g_UIselectedAccountIndex].handler = null;
	UIsetIndicator( g_UIselectedAccountIndex, 0 );
	document.getElementById( "verifyAccountStatusIndicator" ).object.setValue( 0 );
	UIhideVerifyAccount();
}



/***************/
/* settingTabs */
/***************/

function UIshowCheckIntervalSettings()
{
	debug( "UIshowCheckIntervalSettings()" );

	var stackLayout = document.getElementById("settingsStackLayout").object;
	stackLayout.setCurrentView("checkIntervalSettings");
	
	g_pasteTarget = 0;
	document.getElementById("settingsTab1").style.visibility = "visible";
	document.getElementById("settingsTab2").style.visibility = "hidden";
	document.getElementById("settingsTab3").style.visibility = "hidden";
}

function UIshowAudioPlayerSettings()
{
	debug( "UIshowAudioPlayerSettings()" );
	
	var stackLayout = document.getElementById("settingsStackLayout").object;
	stackLayout.setCurrentView("audioPlayerSettings");
	
	g_pasteTarget = 2;
	document.getElementById("settingsTab1").style.visibility = "hidden";
	document.getElementById("settingsTab2").style.visibility = "visible";
	document.getElementById("settingsTab3").style.visibility = "hidden";
}

function UIshowUpdateSettings()
{
	debug( "UIshowUpdateSettings()" );

	var stackLayout = document.getElementById("settingsStackLayout").object;
	stackLayout.setCurrentView("updateSettings");
	
	g_pasteTarget = 0;
	document.getElementById("settingsTab1").style.visibility = "hidden";
	document.getElementById("settingsTab2").style.visibility = "hidden";
	document.getElementById("settingsTab3").style.visibility = "visible";
}



/*****************/
/* CheckInterval */
/*****************/

function UIsetCheckInterval( VALUE )
{
	debug( "UIsetCheckInterval("+ VALUE +")" );
	
	var checkIntervalSlider = document.getElementById("checkIntervalSlider");
	checkIntervalSlider.value = VALUE;
	UIchangeCheckInterval();
}

function UIchangeCheckInterval()
{
	debug( "UIchangeCheckInterval()" );
	
	var checkIntervalSlider = document.getElementById("checkIntervalSlider");
	g_checkInterval = parseInt( checkIntervalSlider.value );

	var textAreaToChange = document.getElementById("checkIntervalCaption");
	var newTextAreaText = dashcode.getLocalizedString( dashcodePartSpecs.checkIntervalCaption.text );
	newTextAreaText = newTextAreaText.replace( /%i/, g_checkInterval );
	textAreaToChange.innerText = newTextAreaText;

	var doCheckIntervalIndicator = document.getElementById("doCheckInterval");

	if ( g_checkInterval ) {
		doCheckIntervalIndicator.style.background = "url( Images/Timer.png ) no-repeat 0 0"
	} else {
		newTextAreaText = dashcode.getLocalizedString( "«Check on showing Dashboard»" );
		textAreaToChange.innerText = newTextAreaText;

		doCheckIntervalIndicator.style.background = "url( Images/Timer.png ) no-repeat 0 -20px";
	}

	resetInterval();
}



/*********************/
/* AudioAnnouncement */
/*********************/

var g_UIpreviousAudio = -1;
var g_UIaudioRestore;

function UIsetVolume( VALUE )
{
	debug( "UIsetVolume("+ VALUE +")")
	var audioVolumeSlider = document.getElementById("audioPlayerVolume");
	audioVolumeSlider.value = VALUE / 2.56;
	UIchangeVolume();
}


function UIchangeVolume()
{
	var audioVolumeSlider = document.getElementById("audioPlayerVolume");
	g_audioVolume = parseInt( audioVolumeSlider.value ) * 2.56;

	var textAreaToChange = document.getElementById("audioPlayerVolumeCaption");
	var newTextAreaText = dashcode.getLocalizedString( dashcodePartSpecs.audioPlayerVolumeCaption.text );
	newTextAreaText = newTextAreaText.replace( /%i/, Math.ceil( g_audioVolume / 25.6 ) );
	textAreaToChange.innerText = newTextAreaText;

	var doAnnounceIndicator = document.getElementById("doAnnounce");

	if ( g_audioVolume ) {
		doAnnounceIndicator.style.background = "url( Images/Announce.png ) no-repeat 0 0"
	} else {
		doAnnounceIndicator.style.background = "url( Images/Announce.png ) no-repeat 0 -20px";
	}
}

function UIaudioDragDrop( EVENT )
{
	debug( "UIaudioDragDrop( " + EVENT + " )" );

	var uriList = getFilesFromEvent( EVENT, true );
	g_customAudio = uriList;
	document.getElementById("audioPlayerDropBox").style.background = "url( Images/dropWell.png ) no-repeat 0 -108px"
	
	EVENT.stopPropagation();
	EVENT.preventDefault();
}

function UIresetAudio()
{
	var dropBox = document.getElementById("audioPlayerDropBox");
	dropBox.style.background = "url( Images/dropWell.png ) no-repeat 0 0"

	delete g_customAudio;
	g_customAudio = null;


	var qtElement = document.getElementById( "audioAnnouncementPlayer" );

	qtElement.Stop();
	qtElement.SetResetPropertiesOnReload(false);
	qtElement.SetURL( g_UIaudioRestore );
}

function UIaudioDragEnter( EVENT )
{
	document.getElementById( "audioPlayerDropBox" ).style.background = "url( Images/dropWell.png ) no-repeat 0 -72px"

	EVENT.stopPropagation();
	EVENT.preventDefault();
}

function UIaudioDragOver( EVENT )
{
	EVENT.stopPropagation();
	EVENT.preventDefault();
}

function UIaudioDragLeave( EVENT )
{
	var dropBox = document.getElementById("audioPlayerDropBox");

	if ( g_customAudio ) {
		dropBox.style.background = "url( Images/dropWell.png ) no-repeat 0 -108px"
	} else {
		dropBox.style.background = "url( Images/dropWell.png ) no-repeat 0 0"
	}

	EVENT.stopPropagation();
	EVENT.preventDefault();
}

function UIplayAudio()
{
	debug( "UIplayAudio()" );

	if ( !g_audioVolume ) {
		return false;
	}

	var qtElement = document.getElementById("audioAnnouncementPlayer");
	var random = 0;
	var newContentURL;
	
	if ( g_customAudio ) {
		if ( g_customAudio.length > 1 ) {
			do {
				random = Math.floor( Math.random() * g_customAudio.length );
			} while ( random == g_UIpreviousAudio );

			g_UIpreviousAudio = random;

			newContentURL = g_customAudio[random];
		} else {
			newContentURL = g_customAudio[0];
		}
	} else {
		do {
			random = Math.floor( Math.random() * 3 );
		} while ( random == g_UIpreviousAudio );

		g_UIpreviousAudio = random;

		newContentURL = random + ".m4a";
	}
	
	debug( newContentURL );

	qtElement.Stop();
	qtElement.SetResetPropertiesOnReload( false );
	qtElement.SetURL( newContentURL );
	debug( qtElement.GetURL() );
	qtElement.SetVolume( g_audioVolume );
	qtElement.Play();
}

function UIgrowlAnnouncement( FROM, SUBJECT ) {
	debug( "UIgrowlAnnouncement( "+FROM+", "+SUBJECT+" )" );
	
	FROM = FROM.replace( /\\/g, "\\\\" );
	FROM = FROM.replace( /"/g, "\\\"" );
	SUBJECT = SUBJECT.replace( /\\/g, "\\\\" );
	SUBJECT = SUBJECT.replace( /"/g, "\\\"" );
	widget.system( "/usr/bin/osascript Growl.applescript \"" + dashcode.getLocalizedString( "«New Mail»" ) + "\" \"" + dashcode.getLocalizedString( "«From»" ) + ": " + FROM + "\" \"" + dashcode.getLocalizedString( "«Subject»" ) + ": " + SUBJECT + "\"", function () {} );
}



/**************/
/* AutoUpdate */
/**************/

function UIsetUpdate( STATE )
{
	debug( "UIsetUpdate("+ STATE +")")
	var updateCheckboxButton = document.getElementById("updateCheckboxButton");
	updateCheckboxButton.checked = STATE;
	UIchangeAutoUpdate();
}

function UIchangeAutoUpdate()
{
	var updateCheckboxButton = document.getElementById("updateCheckboxButton");
	g_autoUpdate = updateCheckboxButton.checked;

	var doAutoUpdateIndicator = document.getElementById( "doAutoUpdate" );

	if ( g_autoUpdate ) {
		doAutoUpdateIndicator.style.background = "url( Images/Update.png ) no-repeat 0 0";
	} else {
		doAutoUpdateIndicator.style.background = "url( Images/Update.png ) no-repeat 0 -20px";
	}
}


/*********************/
/* ActiveAccountName */
/*********************/

//make this manually editable when multiple accounts are checked
/*function UIsetActiveAccountName( NAME )
{
	var textAreaToChange = document.getElementById( "activeAccountName" );
	textAreaToChange.innerText = NAME;
}*/

function getFilesFromEvent( EVENT, DROP )
{
	var uriList;
		
	try {	//Finder files
		var uriString = DROP ? EVENT.dataTransfer.getData( "text/uri-list" ) : EVENT.clipboardData.getData( "text/uri-list" );
		uriList = uriString.split( "\n" );
	} catch (ex) {	
		debug( "Problem fetching URI: " + ex );
		
		try {	//iTunes
			var iTunes = DROP ? EVENT.dataTransfer.getData( "dyn.agk80w7dzr2" ) : EVENT.clipboardData.getData( "dyn.agk80w7dzr2" );
			iTunes = iTunes.split( "\n" );
			uriList = new Array();
			
			for ( var i in iTunes ) {
				if ( iTunes[i].indexOf( "<key>Location</key><string>" ) != -1 ) {
					uriList.push( iTunes[i].substring( iTunes[i].indexOf( "file://" ), iTunes[i].indexOf( "</string>" ) ) );
				}
			}
		} catch (ex) {
			debug( "Problem fetching URI: " + ex );
			throw Error( "No files available!" );
			//uriList = new Array;
		}
	}
	
	return uriList;
}
